#include <iostream>
#include <type_traits>
#include <utility>

template<typename T, typename U>
auto add(T t, U u) -> decltype(std::declval<T>() + std::declval<U>()) {
    return t + u;
}

int main() {
    auto result1 = add(5, 3.14);
    auto result2 = add(std::string("Hello, "), "World!");

    std::cout << "Result 1: " << result1 << std::endl;
    std::cout << "Result 2: " << result2 << std::endl;

    std::cout << "Type of result1: " 
              << (std::is_same<decltype(result1), double>::value ? "double" : "not double") 
              << std::endl;
    std::cout << "Type of result2: " 
              << (std::is_same<decltype(result2), std::string>::value ? "std::string" : "not std::string") 
              << std::endl;

    return 0;
}
